unit iiro8u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Registry, ExtCtrls ;

type
  TMainFrm = class(TForm)
    BeginSample: TButton;
    RunTimer: TTimer;
    NumReads: TPanel;
    RelayRead: TPanel;
    OptoIn: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    AddressLabel: TLabel;
    cbFuzzy: TCheckBox;
    RawCount: TPanel;
    Label1: TLabel;
    Label5: TLabel;
    DeltaCounts: TPanel;
    thresholdedit: TEdit;
    Label6: TLabel;
    cbPaced: TCheckBox;
   // procedure AddressListChange(Sender: TObject);
    procedure RunTimerTimer(Sender: TObject);
    procedure BeginSampleClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
  { Private declarations }
  public
  { Public declarations }
  end;


var
  MainFrm: TMainFrm;

implementation

uses AIOWDM;

var
  count: longword;
  badcount: longword;
  fuzzCount: longword;
  oldvalue: word;
  threshold: word;
  deltaCount: word;
  first:boolean;
{$R *.DFM}

procedure TMainFrm.RunTimerTimer(Sender: TObject);

        procedure fuzzy;
        begin
          if not cbFuzzy.checked then exit;
          if random(10) <> 0 then exit;
          RelOutPortB(0, random(12), random(256));
          inc(fuzzCount);
        end;
var
  value: word;
  code: integer;
  localthresh: word;
begin
    inc(count);

    val( thresholdedit.text, localthresh, code);
    if code = 0 then threshold := localthresh;

    fuzzy;  value := AIOWDM.RelInPortB(0, $10);
    fuzzy;  value := value + (AIOWDM.RelInPortB(0, $10) shl 8);

    if first then begin
        oldvalue := value;
        first:= false;
    end;

    deltaCount := oldvalue - value;

    rawcount.Caption := IntToHex(value, 4);
    deltaCounts.Caption := IntToHex(deltaCount, 4);
    RelayRead.Caption := IntToStr(fuzzCount);
    NumReads.Caption := IntToStr(count);

    if deltaCount > threshold then begin
      inc(badcount);
      OptoIn.caption := inttostr(badcount);
    end;
    oldvalue := value;
end;

procedure TMainFrm.BeginSampleClick(Sender: TObject);
begin

    if BeginSample.Caption[1] = 'S' then Begin
        cbPaced.Enabled := True;
        RunTimer.Enabled := False;
        BeginSample.Caption := 'Perform I/O';
    end else
    begin
        first := true;
        cbPaced.Enabled := False;
        BeginSample.Caption := 'Stop I/O';
        if not cbPaced.checked then
            while BeginSample.Caption[1] = 'S' do begin
              Application.ProcessMessages;
              RunTimerTimer(nil);
            end
        else
            RunTimer.Enabled := True;

    end;




end;

procedure TMainFrm.FormCreate(Sender: TObject);
begin
  count:=0;
  badcount := 0;
  fuzzcount := 0;
  AIOWDM.RelOutportB(0, $13, $34);
  AIOWDM.RelOutportB(0, $10, 0);
  AIOWDM.RelOutportB(0, $10, 0);

  AIOWDM.RelOutportB(0, $13, $74);
  AIOWDM.RelOutportB(0, $11, 0);
  AIOWDM.RelOutportB(0, $11, 0);


end;

END.
